diff --git a/mcs/class/System.Web/System.Web.Security/FormsAuthentication.cs b/mcs/class/System.Web/System.Web.Security/FormsAuthentication.cs
index 2ece407..899237e 100644
--- a/mcs/class/System.Web/System.Web.Security/FormsAuthentication.cs
+++ b/mcs/class/System.Web/System.Web.Security/FormsAuthentication.cs
@@ -45,9 +45,6 @@ namespace System.Web.Security
 	[AspNetHostingPermission (SecurityAction.LinkDemand, Level = AspNetHostingPermissionLevel.Minimal)]
 	public sealed class FormsAuthentication
 	{
-		const int MD5_hash_size = 16;
-		const int SHA1_hash_size = 20;
-
 		static string authConfigPath = "system.web/authentication";
 		static string machineKeyConfigPath = "system.web/machineKey";
 #if TARGET_J2EE
@@ -56,7 +53,6 @@ namespace System.Web.Security
 		const string Forms_cookiePath = "Forms.cookiePath";
 		const string Forms_timeout = "Forms.timeout";
 		const string Forms_protection = "Forms.protection";
-		const string Forms_init_vector = "Forms.init_vector";
 		static bool initialized
 		{
 			get {
@@ -88,11 +84,6 @@ namespace System.Web.Security
 			get { return (FormsProtectionEnum) AppDomain.CurrentDomain.GetData (Forms_protection); }
 			set { AppDomain.CurrentDomain.SetData (Forms_protection, value); }
 		}
-		static byte [] init_vector
-		{
-			get { return (byte []) AppDomain.CurrentDomain.GetData (Forms_init_vector); }
-			set { AppDomain.CurrentDomain.SetData (Forms_init_vector, value); }
-		}
 		static object locker = new object ();
 #else
 		static bool initialized;
@@ -101,7 +92,6 @@ namespace System.Web.Security
 		static int timeout;
 		static FormsProtectionEnum protection;
 		static object locker = new object ();
-		static byte [] init_vector; // initialization vector used for 3DES
 #endif
 #if NET_1_1
 #if TARGET_J2EE
@@ -240,18 +230,6 @@ namespace System.Web.Security
 #endif
 		}
 
-#if NET_2_0
-		static byte [] GetDecryptionKey (MachineKeySection config)
-		{
-			return MachineKeySectionUtils.DecryptionKey192Bits (config);
-		}
-#else
-		static byte [] GetDecryptionKey (MachineKeyConfig config)
-		{
-			return config.DecryptionKey192Bits;
-		}
-#endif
-		
 		static FormsAuthenticationTicket Decrypt2 (byte [] bytes)
 		{
 			if (protection == FormsProtectionEnum.None)
@@ -262,59 +240,14 @@ namespace System.Web.Security
 #else
 			MachineKeyConfig config = HttpContext.GetAppConfig (machineKeyConfigPath) as MachineKeyConfig;
 #endif
-			bool all = (protection == FormsProtectionEnum.All);
-
-			byte [] result = bytes;
-			if (all || protection == FormsProtectionEnum.Encryption) {
-				ICryptoTransform decryptor;
-				decryptor = TripleDES.Create ().CreateDecryptor (GetDecryptionKey (config), init_vector);
-				result = decryptor.TransformFinalBlock (bytes, 0, bytes.Length);
-				bytes = null;
-			}
-
-			if (all || protection == FormsProtectionEnum.Validation) {
-				int count;
-				MachineKeyValidation validationType;
-
-#if NET_2_0
-				validationType = config.Validation;
-#else
-				validationType = config.ValidationType;
-#endif
-				if (validationType == MachineKeyValidation.MD5)
-					count = MD5_hash_size;
-				else
-					count = SHA1_hash_size; // 3DES and SHA1
-
-#if NET_2_0
-				byte [] vk = MachineKeySectionUtils.ValidationKeyBytes (config);
-#else
-				byte [] vk = config.ValidationKey;
-#endif
-				byte [] mix = new byte [result.Length - count + vk.Length];
-				Buffer.BlockCopy (result, 0, mix, 0, result.Length - count);
-				Buffer.BlockCopy (vk, 0, mix, result.Length - count, vk.Length);
-
-				byte [] hash = null;
-				switch (validationType) {
-				case MachineKeyValidation.MD5:
-					hash = MD5.Create ().ComputeHash (mix);
-					break;
-				// From MS docs: "When 3DES is specified, forms authentication defaults to SHA1"
-				case MachineKeyValidation.TripleDES:
-				case MachineKeyValidation.SHA1:
-					hash = SHA1.Create ().ComputeHash (mix);
-					break;
-				}
-
-				if (result.Length < count)
-					throw new ArgumentException ("Error validating ticket (length).", "encryptedTicket");
 
-				int i, k;
-				for (i = result.Length - count, k = 0; k < count; i++, k++) {
-					if (result [i] != hash [k])
-						throw new ArgumentException ("Error validating ticket.", "encryptedTicket");
-				}
+			byte [] result = null;
+			if (protection == FormsProtectionEnum.All) {
+				result = MachineKeySectionUtils.VerifyDecrypt (config, bytes);
+			} else if (protection == FormsProtectionEnum.Encryption) {
+				result = MachineKeySectionUtils.Decrypt (config, bytes);
+			} else if (protection == FormsProtectionEnum.Validation) {
+				result = MachineKeySectionUtils.Verify (config, bytes);
 			}
 
 			return FormsAuthenticationTicket.FromByteArray (result);
@@ -328,11 +261,8 @@ namespace System.Web.Security
 			Initialize ();
 
 			FormsAuthenticationTicket ticket;
-#if NET_2_0
-			byte [] bytes = MachineKeySectionUtils.GetBytes (encryptedTicket, encryptedTicket.Length);
-#else
-			byte [] bytes = MachineKeyConfig.GetBytes (encryptedTicket, encryptedTicket.Length);
-#endif
+			byte [] bytes = Convert.FromBase64String (encryptedTicket);
+
 			try {
 				ticket = Decrypt2 (bytes);
 			} catch (Exception) {
@@ -350,57 +280,23 @@ namespace System.Web.Security
 			Initialize ();
 			byte [] ticket_bytes = ticket.ToByteArray ();
 			if (protection == FormsProtectionEnum.None)
-				return GetHexString (ticket_bytes);
+				return Convert.ToBase64String (ticket_bytes);
 
-			byte [] result = ticket_bytes;
+			byte [] result = null;
 #if NET_2_0
 			MachineKeySection config = (MachineKeySection) WebConfigurationManager.GetWebApplicationSection (machineKeyConfigPath);
 #else
 			MachineKeyConfig config = HttpContext.GetAppConfig (machineKeyConfigPath) as MachineKeyConfig;
 #endif
-			bool all = (protection == FormsProtectionEnum.All);
-			if (all || protection == FormsProtectionEnum.Validation) {
-				byte [] valid_bytes = null;
-#if NET_2_0
-				byte [] vk = MachineKeySectionUtils.ValidationKeyBytes (config);
-#else
-				byte [] vk = config.ValidationKey;
-#endif
-				byte [] mix = new byte [ticket_bytes.Length + vk.Length];
-				Buffer.BlockCopy (ticket_bytes, 0, mix, 0, ticket_bytes.Length);
-				Buffer.BlockCopy (vk, 0, mix, result.Length, vk.Length);
-
-				switch (
-#if NET_2_0
-					config.Validation
-#else
-					config.ValidationType
-#endif
-					) {
-				case MachineKeyValidation.MD5:
-					valid_bytes = MD5.Create ().ComputeHash (mix);
-					break;
-				// From MS docs: "When 3DES is specified, forms authentication defaults to SHA1"
-				case MachineKeyValidation.TripleDES:
-				case MachineKeyValidation.SHA1:
-					valid_bytes = SHA1.Create ().ComputeHash (mix);
-					break;
-				}
-
-				int tlen = ticket_bytes.Length;
-				int vlen = valid_bytes.Length;
-				result = new byte [tlen + vlen];
-				Buffer.BlockCopy (ticket_bytes, 0, result, 0, tlen);
-				Buffer.BlockCopy (valid_bytes, 0, result, tlen, vlen);
+			if (protection == FormsProtectionEnum.All) {
+				result = MachineKeySectionUtils.EncryptSign (config, ticket_bytes);
+			} else if (protection == FormsProtectionEnum.Encryption) {
+				result = MachineKeySectionUtils.Encrypt (config, ticket_bytes);
+			} else if (protection == FormsProtectionEnum.Validation) {
+				result = MachineKeySectionUtils.Sign (config, ticket_bytes);
 			}
 
-			if (all || protection == FormsProtectionEnum.Encryption) {
-				ICryptoTransform encryptor;
-				encryptor = TripleDES.Create ().CreateEncryptor (GetDecryptionKey (config), init_vector);
-				result = encryptor.TransformFinalBlock (result, 0, result.Length);
-			}
-
-			return GetHexString (result);
+			return Convert.ToBase64String (result);
 		}
 
 		public static HttpCookie GetAuthCookie (string userName, bool createPersistentCookie)
@@ -481,21 +377,6 @@ namespace System.Web.Security
 			return returnUrl;
 		}
 
-		static string GetHexString (byte [] bytes)
-		{
-			const int letterPart = 55;
-			const int numberPart = 48;
-			char [] result = new char [bytes.Length * 2];
-			for (int i = 0; i < bytes.Length; i++) {
-				int tmp = (int) bytes [i];
-				int second = tmp & 15;
-				int first = (tmp >> 4) & 15;
-				result [(i * 2)] = (char) (first > 9 ? letterPart + first : numberPart + first);
-				result [(i * 2) + 1] = (char) (second > 9 ? letterPart + second : numberPart + second);
-			}
-			return new string (result);
-		}
-
 		static string HashPasswordForStoringInConfigFile (string password, FormsAuthPasswordFormat passwordFormat)
 		{
 			if (password == null)
@@ -515,7 +396,7 @@ namespace System.Web.Security
 					throw new ArgumentException ("The format must be either MD5 or SHA1", "passwordFormat");
 			}
 
-			return GetHexString (bytes);
+			return MachineKeySectionUtils.GetHexString (bytes);
 		}
 		
 		public static string HashPasswordForStoringInConfigFile (string password, string passwordFormat)
@@ -583,16 +464,6 @@ namespace System.Web.Security
 				}
 #endif
 
-				// IV is 8 bytes long for 3DES
-				init_vector = new byte [8];
-				int len = cookieName.Length;
-				for (int i = 0; i < 8; i++) {
-					if (i >= len)
-						break;
-
-					init_vector [i] = (byte) cookieName [i];
-				}
-
 				initialized = true;
 			}
 		}
diff --git a/mcs/class/System.Web/System.Web.Security/MembershipProvider.cs b/mcs/class/System.Web/System.Web.Security/MembershipProvider.cs
index 4a9556b..71b5e16 100644
--- a/mcs/class/System.Web/System.Web.Security/MembershipProvider.cs
+++ b/mcs/class/System.Web/System.Web.Security/MembershipProvider.cs
@@ -87,57 +87,33 @@ namespace System.Web.Security
 				eh (this, args);
 		}
 
-		SymmetricAlgorithm GetAlg ()
+		SymmetricAlgorithm GetAlgorithm ()
 		{
-			MachineKeySection section = (MachineKeySection) WebConfigurationManager.GetSection ("system.web/machineKey");
+			MachineKeySection section = MachineKeySection.Config;
 
 			if (section.DecryptionKey.StartsWith ("AutoGenerate"))
 				throw new ProviderException ("You must explicitly specify a decryption key in the <machineKey> section when using encrypted passwords.");
 
-			string alg_type = section.Decryption;
-			if (alg_type == "Auto")
-				alg_type = "AES";
+			SymmetricAlgorithm sa = section.GetDecryptionAlgorithm ();
+			if (sa == null)
+				throw new ProviderException (String.Format ("Unsupported decryption attribute '{0}' in <machineKey> configuration section", section.Decryption));
 
-			SymmetricAlgorithm alg = null;
-			if (alg_type == "AES")
-				alg = Rijndael.Create ();
-			else if (alg_type == "3DES")
-				alg = TripleDES.Create ();
-			else
-				throw new ProviderException (String.Format ("Unsupported decryption attribute '{0}' in <machineKey> configuration section", alg_type));
-
-			alg.Key = MachineKeySectionUtils.DecryptionKey192Bits (section);
-			return alg;
+			sa.Key = section.GetDecryptionKey ();
+			return sa;
 		}
 
 		internal const int SALT_BYTES = 16;
 		protected virtual byte [] DecryptPassword (byte [] encodedPassword)
 		{
-			using (SymmetricAlgorithm alg = GetAlg ()) {
-				// alg.Key is set in GetAlg based on web.config
-				// iv is the first part of the encodedPassword
-				byte [] iv = new byte [alg.IV.Length];
-				Array.Copy (encodedPassword, 0, iv, 0, iv.Length);
-				using (ICryptoTransform decryptor = alg.CreateDecryptor (alg.Key, iv)) {
-					return decryptor.TransformFinalBlock (encodedPassword, iv.Length, encodedPassword.Length - iv.Length);
-				}
+			using (SymmetricAlgorithm sa = GetAlgorithm ()) {
+				return MachineKeySectionUtils.Decrypt (sa, encodedPassword, 0, encodedPassword.Length);
 			}
 		}
 
 		protected virtual byte[] EncryptPassword (byte[] password)
 		{
-			using (SymmetricAlgorithm alg = GetAlg ()) {
-				// alg.Key is set in GetAlg based on web.config
-				// alg.IV is randomly set (default behavior) and perfect for our needs
-				byte [] iv = alg.IV;
-				using (ICryptoTransform encryptor = alg.CreateEncryptor (alg.Key, iv)) {
-					byte [] encrypted = encryptor.TransformFinalBlock (password, 0, password.Length);
-					byte [] output = new byte [iv.Length + encrypted.Length];
-					// note: the IV can be public, however it should not be based on the password
-					Array.Copy (iv, 0, output, 0, iv.Length);
-					Array.Copy (encrypted, 0, output, iv.Length, encrypted.Length);
-					return output;
-				}
+			using (SymmetricAlgorithm sa = GetAlgorithm ()) {
+				return MachineKeySectionUtils.Encrypt (sa, password);
 			}
 		}
 	}
diff --git a/mcs/class/System.Web/System.Web.Security/RolePrincipal.cs b/mcs/class/System.Web/System.Web.Security/RolePrincipal.cs
index 36d0211..ece4894 100644
--- a/mcs/class/System.Web/System.Web.Security/RolePrincipal.cs
+++ b/mcs/class/System.Web/System.Web.Security/RolePrincipal.cs
@@ -31,7 +31,6 @@
 #if NET_2_0
 
 using System.Collections.Specialized;
-using System.Security.Cryptography;
 using System.Security.Permissions;
 using System.Security.Principal;
 using System.Web.Configuration;
@@ -143,42 +142,16 @@ namespace System.Web.Security {
 
 			CookieProtection cookieProtection = RoleManagerConfig.CookieProtection;
 
-			if (cookieProtection == CookieProtection.None)
-				return GetBase64FromBytes (ticket.GetBuffer (), 0, (int) ticket.Position);
-			
-			if (cookieProtection == CookieProtection.All || cookieProtection == CookieProtection.Validation) {
-
-				byte [] hashBytes = null;
-				byte [] validationBytes = MachineKeySectionUtils.ValidationKeyBytes (MachineConfig);
-				writer.Write (validationBytes);
-
-				switch (MachineConfig.Validation) {
-					case MachineKeyValidation.MD5:
-						hashBytes = MD5.Create ().ComputeHash (ticket.GetBuffer (), 0, (int) ticket.Position);
-						break;
-
-					case MachineKeyValidation.TripleDES:
-					case MachineKeyValidation.SHA1:
-						hashBytes = SHA1.Create ().ComputeHash (ticket.GetBuffer (), 0, (int) ticket.Position);
-						break;
-				}
-
-				writer.Seek (-validationBytes.Length, SeekOrigin.Current);
-				writer.Write (hashBytes);
-			}
-
-			byte [] ticketBytes = null;
-			if (cookieProtection == CookieProtection.All || cookieProtection == CookieProtection.Encryption) {
-				ICryptoTransform enc;
-				enc = TripleDES.Create ().CreateEncryptor (MachineKeySectionUtils.DecryptionKey192Bits (MachineConfig),
-									   InitVector);
-				ticketBytes = enc.TransformFinalBlock (ticket.GetBuffer (), 0, (int) ticket.Position);
+			byte[] ticket_data = ticket.GetBuffer ();
+			if (cookieProtection == CookieProtection.All) {
+				ticket_data = MachineKeySectionUtils.EncryptSign (MachineConfig, ticket_data);
+			} else if (cookieProtection == CookieProtection.Encryption) {
+				ticket_data = MachineKeySectionUtils.Encrypt (MachineConfig, ticket_data);
+			} else if (cookieProtection == CookieProtection.Validation) {
+				ticket_data = MachineKeySectionUtils.Sign (MachineConfig, ticket_data);
 			}
 
-			if (ticketBytes == null)
-				return GetBase64FromBytes (ticket.GetBuffer (), 0, (int) ticket.Position);
-			else
-				return GetBase64FromBytes (ticketBytes, 0, ticketBytes.Length);
+			return GetBase64FromBytes (ticket_data, 0, ticket_data.Length);
 		}
 
 		void DecryptTicket (string encryptedTicket)
@@ -190,45 +163,18 @@ namespace System.Web.Security {
 			byte [] decryptedTicketBytes = null;
 
 			CookieProtection cookieProtection = RoleManagerConfig.CookieProtection;
-			if (cookieProtection == CookieProtection.All || cookieProtection == CookieProtection.Encryption) {
-				ICryptoTransform decryptor;
-				decryptor = TripleDES.Create ().CreateDecryptor (
-					MachineKeySectionUtils.DecryptionKey192Bits (MachineConfig),
-					InitVector);
-				decryptedTicketBytes = decryptor.TransformFinalBlock (ticketBytes, 0, ticketBytes.Length);
-			}
-			else
-				decryptedTicketBytes = ticketBytes;
-
-			if (cookieProtection == CookieProtection.All || cookieProtection == CookieProtection.Validation) {
-				byte [] validationBytes = MachineKeySectionUtils.ValidationKeyBytes (MachineConfig);
-				byte [] rolesWithValidationBytes = null;
-				byte [] tmpValidation = null;
 
-				int hashSize = (MachineConfig.Validation == MachineKeyValidation.MD5) ? 16 : 20; //md5 is 16 bytes, sha1 is 20 bytes
-
-				rolesWithValidationBytes = new byte [decryptedTicketBytes.Length - hashSize + validationBytes.Length];
-
-				Buffer.BlockCopy (decryptedTicketBytes, 0, rolesWithValidationBytes, 0, decryptedTicketBytes.Length - hashSize);
-				Buffer.BlockCopy (validationBytes, 0, rolesWithValidationBytes, decryptedTicketBytes.Length - hashSize, validationBytes.Length);
-
-				switch (MachineConfig.Validation) {
-					case MachineKeyValidation.MD5:
-						tmpValidation = MD5.Create ().ComputeHash (rolesWithValidationBytes);
-						break;
-
-					case MachineKeyValidation.TripleDES:
-					case MachineKeyValidation.SHA1:
-						tmpValidation = SHA1.Create ().ComputeHash (rolesWithValidationBytes);
-						break;
-				}
-				for (int i = 0; i < tmpValidation.Length; i++) {
-					if (i >= decryptedTicketBytes.Length ||
-						tmpValidation [i] != decryptedTicketBytes [i + decryptedTicketBytes.Length - hashSize])
-						throw new HttpException ("ticket validation failed");
-				}
+			if (cookieProtection == CookieProtection.All) {
+				decryptedTicketBytes = MachineKeySectionUtils.VerifyDecrypt (MachineConfig, ticketBytes);
+			} else if (cookieProtection == CookieProtection.Encryption) {
+				decryptedTicketBytes = MachineKeySectionUtils.Decrypt (MachineConfig, ticketBytes);
+			} else if (cookieProtection == CookieProtection.Validation) {
+				decryptedTicketBytes = MachineKeySectionUtils.Verify (MachineConfig, ticketBytes);
 			}
 
+			if (decryptedTicketBytes == null)
+				throw new HttpException ("ticket validation failed");
+
 			MemoryStream ticket = new MemoryStream (decryptedTicketBytes);
 			BinaryReader reader = new BinaryReader (ticket);
 
@@ -273,11 +219,6 @@ namespace System.Web.Security {
 				_cachedRoles.Add (r, r);
 		}
 
-		byte [] InitVector
-		{
-			get { return new byte [] { 1, 2, 3, 4, 5, 6, 7, 8 }; }
-		}
-		
 		public bool CachedListChanged {
 			get { return _listChanged; }
 		}
diff --git a/mcs/class/System.Web/System.Web.Security/SqlMembershipProvider.cs b/mcs/class/System.Web/System.Web.Security/SqlMembershipProvider.cs
index e8778a4..a042f4c 100644
--- a/mcs/class/System.Web/System.Web.Security/SqlMembershipProvider.cs
+++ b/mcs/class/System.Web/System.Web.Security/SqlMembershipProvider.cs
@@ -1048,11 +1048,22 @@ namespace System.Web.Security {
 
 					MembershipSection section = (MembershipSection) WebConfigurationManager.GetSection ("system.web/membership");
 					string alg_type = section.HashAlgorithmType;
-					if (alg_type == "") {
-						MachineKeySection keysection = (MachineKeySection) WebConfigurationManager.GetSection ("system.web/machineKey");
-						alg_type = keysection.Validation.ToString ();
+					if (alg_type.Length == 0) {
+						alg_type = MachineKeySection.Config.Validation.ToString ();
+#if NET_4_0
+						// support new (4.0) custom algorithms
+						if (alg_type.StartsWith ("alg:"))
+							alg_type = alg_type.Substring (4);
+#endif
 					}
 					using (HashAlgorithm hash = HashAlgorithm.Create (alg_type)) {
+#if NET_4_0
+						// for compatibility (with 2.0) we'll allow MD5 and SHA1 not to map to HMACMD5 and HMACSHA1
+						// but that won't work with new (4.0) algorithms, like HMACSHA256|384|512 or custom, won't work without using the key
+						KeyedHashAlgorithm kha = (hash as KeyedHashAlgorithm);
+						if (kha != null)
+							kha.Key = MachineKeySection.Config.GetValidationKey ();
+#endif
 						hash.TransformFinalBlock (hashBytes, 0, hashBytes.Length);
 						return Convert.ToBase64String (hash.Hash);
 					}
diff --git a/mcs/class/System.Web/System.Web.SessionState/SessionId.cs b/mcs/class/System.Web/System.Web.SessionState/SessionId.cs
index c1eac4d..2161745 100644
--- a/mcs/class/System.Web/System.Web.SessionState/SessionId.cs
+++ b/mcs/class/System.Web/System.Web.SessionState/SessionId.cs
@@ -28,15 +28,12 @@
 
 using System.Text;
 using System.Security.Cryptography;
+using System.Web.Configuration;
 
 namespace System.Web.SessionState {
 
 	internal class SessionId {
 
-		static char [] allowed = { '0', '1', '2', '3', '4', '5',
-						   '6', '7', '8', '9', 'A', 'B',
-						   'C', 'D', 'E', 'F' };
-
 		internal const int IdLength = 24;
 		const int half_len = IdLength / 2;
 		static RandomNumberGenerator rng = RandomNumberGenerator.Create ();
@@ -48,25 +45,9 @@ namespace System.Web.SessionState {
 			lock (rng) {
 				rng.GetBytes (key);
 			}
-			return Encode (key);
+			return MachineKeySectionUtils.GetHexString (key);
 		}
 
-		internal static string Encode (byte[] key)
-		{
-			if (key == null)
-				throw new ArgumentNullException ("key");
-			if (key.Length != half_len)
-				throw new ArgumentException (String.Concat ("key must be ", half_len.ToString (), " bytes long."));
-
-			// Just a standard hex conversion
-			char[] res = new char [IdLength];
-			for (int i=0; i < half_len; i++) {
-				int b = key [i];
-				res [i * 2] = allowed [b >> 4];
-				res [(i * 2) + 1] = allowed [b & 0xF];
-			}
-			return new String (res);
-		}
 #if !NET_2_0
 		internal static string Lookup (HttpRequest request, bool cookieless)
 		{
diff --git a/mcs/class/System.Web/System.Web.UI/LosFormatter.cs b/mcs/class/System.Web/System.Web.UI/LosFormatter.cs
index d146e18..4cb250d 100644
--- a/mcs/class/System.Web/System.Web.UI/LosFormatter.cs
+++ b/mcs/class/System.Web/System.Web.UI/LosFormatter.cs
@@ -28,10 +28,11 @@
 // WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 //
 
+using System.Configuration;
 using System.IO;
-using System.Security.Cryptography;
 using System.Security.Permissions;
 using System.Text;
+using System.Web.Configuration;
 
 namespace System.Web.UI {
 
@@ -48,11 +49,14 @@ namespace System.Web.UI {
 
 #if NET_1_1
 		public LosFormatter (bool enableMac, string macKeyModifier)
-			: this (enableMac, Convert.FromBase64String (macKeyModifier))
 		{
+			osf = new ObjectStateFormatter ();
+			if (enableMac && macKeyModifier != null && macKeyModifier.Length > 0) {
+				SetMacKey (Convert.FromBase64String (macKeyModifier));
+			}
 		}
 #endif
-		[MonoTODO]
+
 #if NET_2_0
 		public
 #else
@@ -60,25 +64,53 @@ namespace System.Web.UI {
 #endif
 		LosFormatter (bool enableMac, byte[] macKeyModifier)
 		{
-			if (enableMac)
-				osf = new ObjectStateFormatter (macKeyModifier);
-			else
-				osf = new ObjectStateFormatter ();
+			osf = new ObjectStateFormatter ();
+			if (enableMac && (macKeyModifier != null)) {
+				SetMacKey (macKeyModifier);
+			}
 		}
 
+		void SetMacKey (byte[] macKeyModifier)
+		{
+			try {
+#if NET_2_0
+				osf.Section.ValidationKey = MachineKeySectionUtils.GetHexString (macKeyModifier);
+#else
+				osf.Section.SetValidationKey (MachineKeySectionUtils.GetHexString (macKeyModifier));
+#endif
+			}
+			catch (ArgumentException) {
+			}
+#if NET_2_0
+			catch (ConfigurationErrorsException) {
+				// bad key (e.g. size), default key will be used
+			}
+#else
+			catch (HttpException) {
+				// bad key (e.g. size), default key will be used
+			}
+#endif
+                }
+		
 		public object Deserialize (Stream stream)
 		{
 			if (stream == null)
 				throw new ArgumentNullException ("stream");
+#if NET_4_0
+			using (StreamReader sr = new StreamReader (stream)) {
+				return Deserialize (sr.ReadToEnd ());
+			}
+#else
 			long streamLength = -1;
 			if (stream.CanSeek)
 				streamLength = stream.Length;
-			byte [] bytes = new byte [streamLength >= 0 ? streamLength : 2048];
+			
 			MemoryStream ms = null;
 			if (streamLength  != -1 && (stream is MemoryStream) && stream.Position == 0) {
 				// We save allocating a new stream and reading in this case.
 				ms = (MemoryStream) stream;
 			} else {
+				byte [] bytes = new byte [streamLength >= 0 ? streamLength : 2048];	
 				ms = new MemoryStream ();
 				int n;
 				while ((n = stream.Read (bytes, 0, bytes.Length)) > 0)
@@ -89,6 +121,7 @@ namespace System.Web.UI {
 			string b64 = Encoding.ASCII.GetString (ms.GetBuffer (),
 				0, (int) streamLength);
 			return Deserialize (b64);
+#endif
 		}
 
 		public object Deserialize (TextReader input)
@@ -116,7 +149,10 @@ namespace System.Web.UI {
 		{
 			if (stream == null)
 				throw new ArgumentNullException ("stream");
-
+#if NET_4_0
+			if (!stream.CanSeek)
+				throw new NotSupportedException ();
+#endif
 			string b64 = SerializeToBase64 (value);
 			byte [] bytes = Encoding.ASCII.GetBytes (b64);
 			stream.Write (bytes, 0, bytes.Length);
diff --git a/mcs/class/System.Web/System.Web.UI/ObjectStateFormatter.cs b/mcs/class/System.Web/System.Web.UI/ObjectStateFormatter.cs
index a73e4af..20cb068 100644
--- a/mcs/class/System.Web/System.Web.UI/ObjectStateFormatter.cs
+++ b/mcs/class/System.Web/System.Web.UI/ObjectStateFormatter.cs
@@ -44,7 +44,6 @@ using System.Text;
 using System.Web.UI.WebControls;
 using System.Web.Util;
 using System.Diagnostics;
-using System.Security.Cryptography;
 using System.Web.Configuration;
 
 namespace System.Web.UI {
@@ -56,9 +55,11 @@ namespace System.Web.UI {
 	sealed class ObjectStateFormatter : IFormatter, IStateFormatter
 	{
 		Page page;
-		HashAlgorithm algo;
-		byte [] vkey;
-
+#if NET_2_0
+		MachineKeySection section;
+#else
+		MachineKeyConfig section;
+#endif
 		public ObjectStateFormatter ()
 		{
 		}
@@ -67,18 +68,11 @@ namespace System.Web.UI {
 		{
 			this.page = page;
 		}
-
-		internal ObjectStateFormatter (byte [] vkey)
-		{
-			this.vkey = vkey;
-		}
 		
-		internal bool EnableMac {
+		bool EnableMac {
 			get {
 				if (page == null) {
-					if (vkey == null)
-						return false;
-					return true;
+					return section != null;
 				} else {
 				
 #if NET_2_0
@@ -92,48 +86,44 @@ namespace System.Web.UI {
 			}
 		}
 
-		internal HashAlgorithm GetAlgo ()
-		{
-			if (algo != null)
-				return algo;
-			if (!EnableMac)
-				return null;
-			
-			byte [] algoKey;
-			if (page != null) {
+		bool NeedViewStateEncryption {
+			get {
 #if NET_2_0
-				MachineKeySection mconfig = (MachineKeySection) WebConfigurationManager.GetWebApplicationSection ("system.web/machineKey");
-				algoKey = MachineKeySectionUtils.ValidationKeyBytes (mconfig);
+				return (page == null) ? false : page.NeedViewStateEncryption;
 #else
-				MachineKeyConfig mconfig = HttpContext.GetAppConfig ("system.web/machineKey") as MachineKeyConfig;
-				algoKey = mconfig.ValidationKey;
+				return false;
 #endif
-			} else
-				algoKey = vkey;
-
-			algo = new HMACSHA1 (algoKey);
-			return algo;
+			}
 		}
-
-		static int ValidateInput (HashAlgorithm algo, byte [] data, int offset, int size)
-		{
-			if (algo == null)
-				throw new HttpException ("Unable to validate data.");
-			
-			int hash_size = algo.HashSize / 8;
-			if (size != 0 && size < hash_size)
-				throw new HttpException ("Unable to validate data.");
-
-			int data_length = size - hash_size;
-			MemoryStream data_stream = new MemoryStream (data, offset, data_length, false, false);
-			byte [] hash = algo.ComputeHash (data_stream);
-			for (int i = 0; i < hash_size; i++) {
-				if (hash [i] != data [data_length + i])
-					throw new HttpException ("Unable to validate data.");
-			}
-			return data_length;
+#if NET_2_0
+		internal MachineKeySection Section {
+			get {
+				if (section == null)
+					section = (MachineKeySection) WebConfigurationManager.GetWebApplicationSection ("system.web/machineKey");
+				return section;
+			}
+			set {
+				section = value;
+			}
 		}
-		
+#else
+		internal MachineKeyConfig Section {
+			get {
+				if (section == null) {
+					HttpContext context = HttpContext.Current;
+					if (context == null)
+						section = new MachineKeyConfig (null);
+					else
+						section = (MachineKeyConfig) context.GetConfig ("system.web/machineKey");
+				}
+				
+				return section;
+			}
+			set {
+				section = value;
+			}
+		}
+#endif		
 		public object Deserialize (Stream inputStream)
 		{
 			if (inputStream == null)
@@ -153,21 +143,25 @@ namespace System.Web.UI {
 			if (inputString == "")
 				return "";
 #endif
-			byte [] buffer = Convert.FromBase64String (inputString);
-			int length;
-			if (buffer == null || (length = buffer.Length) == 0)
+			byte [] data = Convert.FromBase64String (inputString);
+			if (data == null || (data.Length) == 0)
 				throw new ArgumentNullException ("inputString");
-			if (page != null && EnableMac)
-				length = ValidateInput (GetAlgo (), buffer, 0, length);
-#if NET_2_0
-			bool isEncrypted = ((int)buffer [--length] == 1)? true : false;
-#endif
-			Stream ms = new MemoryStream (buffer, 0, length, false, false);
-#if NET_2_0
-			if (isEncrypted)
-				ms = new CryptoStream (ms, page.GetCryptoTransform (CryptoStreamMode.Read), CryptoStreamMode.Read);
-#endif
-			return Deserialize (ms);
+			if (NeedViewStateEncryption) {
+				if (EnableMac) {
+					data = MachineKeySectionUtils.VerifyDecrypt (Section, data);
+				} else {
+					data = MachineKeySectionUtils.Decrypt (Section, data);
+				}
+			} else if (EnableMac) {
+				data = MachineKeySectionUtils.Verify (Section, data);
+			}
+
+			if (data == null)
+				throw new HttpException ("Unable to validate data.");
+
+			using (MemoryStream ms = new MemoryStream (data)) {
+				return Deserialize (ms);
+			}
 		}
 		
 		public string Serialize (object stateGraph)
@@ -175,31 +169,23 @@ namespace System.Web.UI {
 			if (stateGraph == null)
 				return "";
 			
-			MemoryStream ms = new MemoryStream ();
-			Stream output = ms;
-#if NET_2_0
-			bool needEncryption = page == null ? false : page.NeedViewStateEncryption;
-			if (needEncryption){
-				output = new CryptoStream (output, page.GetCryptoTransform (CryptoStreamMode.Write), CryptoStreamMode.Write);
+			byte[] data = null;
+			using (MemoryStream ms = new MemoryStream ()) {
+				Serialize (ms, stateGraph);
+				data = ms.GetBuffer ();
 			}
-#endif
-			Serialize (output, stateGraph);
-#if NET_2_0
-			ms.WriteByte((byte)(needEncryption? 1 : 0));
-#endif
-			
-#if TRACE
-			ms.WriteTo (File.OpenWrite (Path.GetTempFileName ()));
-#endif
-			if (EnableMac && ms.Length > 0) {
-				HashAlgorithm algo = GetAlgo ();
-				if (algo != null) {
-					byte [] hash = algo.ComputeHash (ms.GetBuffer (), 0, (int) ms.Length);
-					ms.Write (hash, 0, hash.Length);
+
+			if (NeedViewStateEncryption) {
+				if (EnableMac) {
+					data = MachineKeySectionUtils.EncryptSign (Section, data);
+				} else {
+					data = MachineKeySectionUtils.Encrypt (Section, data);
 				}
-				
+			} else if (EnableMac) {
+				data = MachineKeySectionUtils.Sign (Section, data);
+
 			}
-			return Convert.ToBase64String (ms.GetBuffer (), 0, (int) ms.Length);
+			return Convert.ToBase64String (data, 0, data.Length);
 		}
 		
 		public void Serialize (Stream outputStream, object stateGraph)
